<?php
// Mikrotik Freshbooks Intergration Script v1.0
//
// Jim Bouse
// jim@mobileitpro.com
// http://jimbouse.com/post/2012/10/09/FreshBooks-and-Mikrotik-Automatic-Non-Payment-Script.aspx
// October 9, 2012
//
// License: None...  Feel free to use, modify, butcher, whatever, this code.  I ask that if you add features, you send me a copy.
//
// Plug: I own and operate an WISP that uses Ubiquiti and Mikrotik equipment.  I also do consulting work and onsite assistance.

require('config.php');
require('routeros_api.class.php');
?>	
<html>
	<body>
		<h3>Generate Mailing E-Mail Address List</h3>
		<form method="get">
			<input type="hidden" name="event" value="fetch.email">
			<input type="text" name="email_create" value="<?php echo $_GET['email_create'];?>"> Your Email<Br>
			<input type="text" name="subject_create" value="<?php echo $_GET['subject_create'];?>"> Email Subject<br>
			
			<input type="submit" value="Fetch E-Mail Addresses">
		</form>
		<hr>
	</body>
</html>
<?php
if ($_GET['event'] == "fetch.email") {
	// Connect to Freshbooks and then compare to Mikrotik Simple Queues.
	// If customer name is found in Simple Queue, add their e-mail address to output.
	//
	// get total page count @ 100 per results page
	$total_count = 0;
	$xml = '<request method="client.list">';
		$xml .= '<per_page>100</per_page>';
	$xml .= '</request>';
	$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
	$pages = $result->clients['pages'];
	
	$i = 1;
	while ($i <= $pages) {
		// each page will be fetched
		$xml = '<request method="client.list">';
			$xml .= '<page>'.$i++.'</page>';
			$xml .= '<per_page>100</per_page>';
		$xml .= '</request>';
		$result = new SimpleXMLElement(PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml));
		foreach ($result -> clients[0] -> client as $row) {
			// each record in the page will be added to the array
			$first_name = $row->first_name;
			$last_name = $row->last_name;
			$email = $row->email;
			$name = $last_name.", ".$first_name;
			$Customers[$name] = $email;
		}

	}
	
	$mikrotik_ip_array = str_getcsv($mikrotik_ip_list_csv,",");
	foreach ($mikrotik_ip_array as $mikrotik_ip) {
		$count = 0;
		$API = new routeros_api();
		$API->debug = false;
		if ($API->connect($mikrotik_ip, $mikrotik_user, $mikrotik_pass)) {
			$API->write('/queue/simple/getall');
			$READ = $API->read(false);
			$ARRAY = $API->parse_response($READ);

			foreach( $ARRAY as $Queue ) {
				// compare to Customers array.
				if (array_key_exists($Queue['name'], $Customers)) {
					$count++;
					$email_out .= $Customers[$Queue['name']].", ";
					$email_out_sc .= $Customers[$Queue['name']]."; ";
				}
				foreach ($Customers as $name => $email) {
					if ($name == $Queue['name']) {
				//		$email_out .= $email."; ";
					}
				}
			}
			$API->disconnect();
			$total_count = $total_count + $count;
			echo $mikrotik_ip .": ".$count." results<br>";
		}
	}
	
	echo "<h3>".$total_count." Results</h3>";
	echo '<a href="mailto:'.$_GET['email_create'].'?subject='.$_GET['subject_create'].'&bcc='.substr($email_out_sc, 0, -2).'" onClick="window.location=\''.$BaseURL.'email.php\';">This link should launch your OUTLOOK mail client with the customers in the BCC</a><br>';
	echo '<a href="mailto:'.$_GET['email_create'].'?subject='.$_GET['subject_create'].'&bcc='.substr($email_out, 0, -2).'" onClick="window.location=\''.$BaseURL.'email.php\';">This link should launch your ThunderBird mail client with the customers in the BCC</a>';
	echo "<h3>Comma Seperated</h3>";		
	echo substr($email_out, 0, -2);
	echo "<BR>";
	echo "<h3>Semi-Colon Seperated (Outlook)</h3>";		
	echo substr($email_out_sc, 0, -2);

	
	die;
}
?>