<?php
// Mikrotik Freshbooks Intergration Script v1.0
//
// Jim Bouse
// jim@mobileitpro.com
// http://jimbouse.com/post/2012/10/09/FreshBooks-and-Mikrotik-Automatic-Non-Payment-Script.aspx
// October 9, 2012
//
// License: None...  Feel free to use, modify, butcher, whatever, this code.  I ask that if you add features, you send me a copy.
//
// Plug: I own and operate an WISP that uses Ubiquiti and Mikrotik equipment.  I also do consulting work and onsite assistance.

$RemoteIP = $_SERVER["REMOTE_HOST"];

$CompanyName = "Company Name";
$CompanyPhone = "555-555-5555";

$OAuth = "lkjaljfdlaksdflkjalsdjflajsdf"; // see: http://developers.freshbooks.com/authentication-2/
$BaseURL = "http://".$_SERVER["HTTP_HOST"]."/"; // the publically accessable url for this directory "http://example.com/payments/"
$FreshbooksCompanyURL = "https://company.freshbooks.com"; // FreshBooks company url

$mikrotik_ip_list_csv = "172.16.100.1,172.16.100.100"; // "xxx.xxx.xxx.xxx,yyy.yyy.yyy.yyy,zzz.zzz.zzz.zzz"
$mikrotik_user = "api-user-username"; // user must have full access on each Mikrotik listed in the line above
$mikrotik_pass = "api-user-password"; // password on Mikrotiks

$log = FALSE; // set to TRUE if you want to log each request (for debugging).

if ($log == TRUE) {
	$req_dump = print_r($_REQUEST, TRUE);
	$fp = fopen('request.log', 'a');
	fwrite($fp, $req_dump);
	fclose($fp);
}

function PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml) {
	$url = $FreshbooksCompanyURL."/api/2.1/xml-in";
	$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_MUTE, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_USERPWD, $OAuth.":X");
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: text/xml'));
		curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$output = curl_exec($ch);
	curl_close($ch);
	return $output;
}
?>