<?php
// Mikrotik Freshbooks Intergration Script v1.0
//
// Jim Bouse
// jim@mobileitpro.com
// http://jimbouse.com/post/2012/10/09/FreshBooks-and-Mikrotik-Automatic-Non-Payment-Script.aspx
// October 9, 2012
//
// License: None...  Feel free to use, modify, butcher, whatever, this code.  I ask that if you add features, you send me a copy.
//
// Plug: I own and operate an WISP that uses Ubiquiti and Mikrotik equipment.  I also do consulting work and onsite assistance.

require('config.php');

$alert = "";
if ($_POST['event'] == "callback.create") {
	if (!$_POST['callback'] == '') {
		$xml = '<request method="callback.create">';
			$xml .= '<callback>';
				$xml .= '<event>'.$_POST['callback'].'</event>';
				$xml .= '<uri>'.$BaseURL.'</uri>';
			$xml .= '</callback>';
		$xml .= '</request>';
		PostToFreshbooks($FreshbooksCompanyURL, $OAuth, $xml);
		$alert = "<script>alert('Request sent to add \"".$_POST['callback']."\" to Freshbooks.');</script>";
	}
}
?>
	
<html>
	<body>
		<?php echo $alert; ?>
		<h3>Create New Callback</h3>
		<form method="POST">
			<select name="callback">
				<option value="all">All Events Listed</option>
				<optgroup label="Categories">
					<option value="category">All Category Events</option>
					<option value="category.create">Category Create</option>
					<option value="category.delete">Category Delete</option>
					<option value="category.update">Category Update</option>
				</optgroup>
				<optgroup label="Clients">
					<option value="client">All Client Events</option>
					<option value="client.create">Client Create</option>
					<option value="client.delete">Client Delete</option>
					<option value="client.update">Client Update</option>
				</optgroup>
				<optgroup label="Estimates">
					<option value="estimate">All Estimate Events</option>
					<option value="estimate.create">Estimate Create</option>
					<option value="estimate.delete">Estimate Delete</option>
					<option value="estimate.sendByEmail">Estimate Email</option>
					<option value="estimate.update">Estimate Update</option>
				</optgroup>
				<optgroup label="Invoices">
					<option value="invoice">All Standard Invoice Events</option>
					<option value="invoice.create">Invoice Create</option>
					<option value="invoice.delete">Invoice Delete</option>
					<option value="invoice.dispute">Invoice Dispute</option>
					<option value="invoice.pastdue.1">Invoice Past Due 1</option>
					<option value="invoice.pastdue.2">Invoice Past Due 2</option>
					<option value="invoice.pastdue.3">Invoice Past Due 3</option>
					<option value="invoice.sendByEmail">Invoice Email</option>
					<option value="invoice.sendBySnailMail">Invoice Snail Mail</option>
					<option value="invoice.update">Invoice Update</option>
				</optgroup>
				<optgroup label="Recurring Invoices">
					<option value="recurring">All Recurring Invoice Events</option>
					<option value="recurring.create">Recurring Invoice Create</option>
					<option value="recurring.delete">Recurring Invoice Delete</option>
					<option value="recurring.update">Recurring Invoice Update</option>
				</optgroup>
				<optgroup label="Items">
					<option value="item">All Item Events</option>
					<option value="item.create">Item Create</option>
					<option value="item.delete">Item Delete</option>
					<option value="item.update">Item Update</option>
				</optgroup>
				<optgroup label="Payments">
					<option value="payment">All Payment Events</option>
					<option value="payment.create">Payment Create</option>
					<option value="payment.delete">Payment Delete</option>
					<option value="payment.upgrade">Payment Update</option>
				</optgroup>
				<optgroup label="Staff">
					<option value="staff">All Staff Events</option>
					<option value="staff.create">Staff Create</option>
					<option value="staff.delete">Staff Delete</option>
					<option value="staff.update">Staff Update</option>
				</optgroup>
				<optgroup label="Tasks">
					<option value="task">All Task Events</option>
					<option value="task.create">Task Create</option>
					<option value="task.delete">Task Delete</option>
					<option value="task.update">Task Update</option>
				</optgroup>
				<optgroup label="Time">
					<option value="time_entry">All Time Events</option>
					<option value="time_entry.create">Time Create</option>
					<option value="time_entry.delete">Time Delete</option>
					<option value="time_entry.update">Time Update</option>
				</optgroup>
			</select>
			<input type="hidden" name="event" value="callback.create">
			<input type="submit">
		</form>

		
	</body>
</html>